import * as myModule from "./ink.js";

runOnStartup(async runtime => {

    async function setupStory() {
        try {
            const response = await fetch("myStory.json");
            const storyJson = await response.json();
            window.currentStory = new inkjs.Story(storyJson);
            continueStory();
        } catch (err) {
            console.error('Error loading story:', err);
        }
    }

    function continueStory() {
        let storyText = "";

        while (window.currentStory.canContinue) {
            storyText += window.currentStory.Continue() + "\n";
        }

        const storyTextInstance = runtime.objects.StoryText.getFirstInstance();
        storyTextInstance.text = storyText;


        for (let i = 1; i <= 4; i++) { //Change this number to the amount of maximum choices in your game.
            const choiceButton = runtime.objects[`Choice${i}`].getFirstInstance();
            choiceButton.isVisible = false;
        }


        window.currentStory.currentChoices.forEach((choice, index) => {
            if (index < 4) { //Change this number to the amount of maximum choices in your game.
                const choiceButton = runtime.objects[`Choice${index + 1}`].getFirstInstance();
                choiceButton.text = choice.text;
                choiceButton.isVisible = true;
            }
        });
    }

    window.selectChoice = function(choiceIndex) {
        if (choiceIndex >= 0 && choiceIndex < window.currentStory.currentChoices.length) {
            window.currentStory.ChooseChoiceIndex(choiceIndex);
            continueStory();
        } else {
            console.error("Choice index out of range:", choiceIndex);
        }
    };

    setupStory();
});
